import { $arkTypeRegistry, scope } from "../scope.js";
import { arkBuiltins } from "./builtins.js";
import { arkPrototypes } from "./constructors/constructors.js";
import { number } from "./number/number.js";
import { string } from "./string/string.js";
import { arkTsGenerics, arkTsKeywords, unknown } from "./ts.js";
$arkTypeRegistry.typeAttachments = {
    ...arkTsKeywords,
    Key: arkBuiltins.Key,
    Record: arkTsGenerics.Record
};
export const ambient = scope({
    ...arkTsKeywords,
    ...arkTsGenerics,
    ...arkPrototypes,
    ...arkBuiltins,
    string,
    number,
    unknown
}, { prereducedAliases: true, ambient: true });
export const ark = ambient.export();
export const type = ambient.type;
export const generic = ambient.generic;
export const define = ambient.define;
export const declare = ambient.declare;
